--[[
Name: LibBabble-Faction-3.0
Revision: $Rev: 170 $
Maintainers: ckknight, nevcairiel, Ackis
Website: http://www.wowace.com/projects/libbabble-faction-3-0/
Dependencies: None
License: MIT
]]

local MAJOR_VERSION = "LibBabble-Faction-3.0"
local MINOR_VERSION = 90000 + tonumber(("$Rev: 170 $"):match("%d+"))

if not LibStub then error(MAJOR_VERSION .. " requires LibStub.") end
local lib = LibStub("LibBabble-3.0"):New(MAJOR_VERSION, MINOR_VERSION)
if not lib then return end

local GAME_LOCALE = GetLocale()

lib:SetBaseTranslations {
	Acquaintance = "Acquaintance",
	Alliance = "Alliance",
	["Alliance Vanguard"] = "Alliance Vanguard",
	["Argent Crusade"] = "Argent Crusade",
	["Argent Dawn"] = "Argent Dawn",
	["Ashtongue Deathsworn"] = "Ashtongue Deathsworn",
	["Avengers of Hyjal"] = "Avengers of Hyjal",
	["Baradin's Wardens"] = "Baradin's Wardens",
	["Best Friend"] = "Best Friend",
	["Bilgewater Cartel"] = "Bilgewater Cartel",
	["Bloodsail Buccaneers"] = "Bloodsail Buccaneers",
	["Booty Bay"] = "Booty Bay",
	["Brood of Nozdormu"] = "Brood of Nozdormu",
	Buddy = "Buddy",
	["Cenarion Circle"] = "Cenarion Circle",
	["Cenarion Expedition"] = "Cenarion Expedition",
	["Chee Chee"] = "Chee Chee",
	["Darkmoon Faire"] = "Darkmoon Faire",
	["Darkspear Trolls"] = "Darkspear Trolls",
	Darnassus = "Darnassus",
	["Dragonmaw Clan"] = "Dragonmaw Clan",
	Ella = "Ella",
	Everlook = "Everlook",
	Exalted = "Exalted",
	Exodar = "Exodar",
	["Explorers' League"] = "Explorers' League",
	["Farmer Fung"] = "Farmer Fung",
	["Fish Fellreed"] = "Fish Fellreed",
	["Forest Hozen"] = "Forest Hozen",
	["Frenzyheart Tribe"] = "Frenzyheart Tribe",
	Friend = "Friend",
	Friendly = "Friendly",
	["Frostwolf Clan"] = "Frostwolf Clan",
	Gadgetzan = "Gadgetzan",
	["Gelkis Clan Centaur"] = "Gelkis Clan Centaur",
	Gilneas = "Gilneas",
	["Gina Mudclaw"] = "Gina Mudclaw",
	Gnomeregan = "Gnomeregan",
	["Gnomeregan Exiles"] = "Gnomeregan Exiles",
	["Golden Lotus"] = "Golden Lotus",
	["Good Friend"] = "Good Friend",
	["Guardians of Hyjal"] = "Guardians of Hyjal",
	Guild = "Guild",
	["Haohan Mudclaw"] = "Haohan Mudclaw",
	["Hellscream's Reach"] = "Hellscream's Reach",
	Honored = "Honored",
	["Honor Hold"] = "Honor Hold",
	Horde = "Horde",
	["Horde Expedition"] = "Horde Expedition",
	["Huojin Pandaren"] = "Huojin Pandaren",
	["Hydraxian Waterlords"] = "Hydraxian Waterlords",
	Ironforge = "Ironforge",
	["Jogu the Drunk"] = "Jogu the Drunk",
	["Keepers of Time"] = "Keepers of Time",
	["Kirin Tor"] = "Kirin Tor",
	["Knights of the Ebon Blade"] = "Knights of the Ebon Blade",
	Kurenai = "Kurenai",
	["Lower City"] = "Lower City",
	["Magram Clan Centaur"] = "Magram Clan Centaur",
	["Nat Pagle"] = "Nat Pagle",
	Netherwing = "Netherwing",
	Neutral = "Neutral",
	["Ogri'la"] = "Ogri'la",
	["Old Hillpaw"] = "Old Hillpaw",
	["Order of the Cloud Serpent"] = "Order of the Cloud Serpent",
	Orgrimmar = "Orgrimmar",
	["Pearlfin Jinyu"] = "Pearlfin Jinyu",
	Ramkahen = "Ramkahen",
	Ratchet = "Ratchet",
	Ravenholdt = "Ravenholdt",
	Revered = "Revered",
	["Shado-Pan"] = "Shado-Pan",
	["Shang Xi's Academy"] = "Shang Xi's Academy",
	["Sha'tari Skyguard"] = "Sha'tari Skyguard",
	["Shattered Sun Offensive"] = "Shattered Sun Offensive",
	["Shen'dralar"] = "Shen'dralar",
	Sho = "Sho",
	["Silvermoon City"] = "Silvermoon City",
	["Silverwing Sentinels"] = "Silverwing Sentinels",
	Sporeggar = "Sporeggar",
	["Stormpike Guard"] = "Stormpike Guard",
	Stormwind = "Stormwind",
	Stranger = "Stranger",
	Syndicate = "Syndicate",
	["The Aldor"] = "The Aldor",
	["The Anglers"] = "The Anglers",
	["The Ashen Verdict"] = "The Ashen Verdict",
	["The August Celestials"] = "The August Celestials",
	["The Black Prince"] = "The Black Prince",
	["The Brewmasters"] = "The Brewmasters",
	["The Consortium"] = "The Consortium",
	["The Defilers"] = "The Defilers",
	["The Earthen Ring"] = "The Earthen Ring",
	["The Frostborn"] = "The Frostborn",
	["The Hand of Vengeance"] = "The Hand of Vengeance",
	["The Kalu'ak"] = "The Kalu'ak",
	["The Klaxxi"] = "The Klaxxi",
	["The League of Arathor"] = "The League of Arathor",
	["The Lorewalkers"] = "The Lorewalkers",
	["The Mag'har"] = "The Mag'har",
	["The Oracles"] = "The Oracles",
	Therazane = "Therazane",
	["The Scale of the Sands"] = "The Scale of the Sands",
	["The Scryers"] = "The Scryers",
	["The Sha'tar"] = "The Sha'tar",
	["The Silver Covenant"] = "The Silver Covenant",
	["The Sons of Hodir"] = "The Sons of Hodir",
	["The Sunreavers"] = "The Sunreavers",
	["The Taunka"] = "The Taunka",
	["The Tillers"] = "The Tillers",
	["The Violet Eye"] = "The Violet Eye",
	["The Wyrmrest Accord"] = "The Wyrmrest Accord",
	["Thorium Brotherhood"] = "Thorium Brotherhood",
	Thrallmar = "Thrallmar",
	["Thunder Bluff"] = "Thunder Bluff",
	["Timbermaw Hold"] = "Timbermaw Hold",
	["Tina Mudclaw"] = "Tina Mudclaw",
	Tranquillien = "Tranquillien",
	["Tushui Pandaren"] = "Tushui Pandaren",
	Undercity = "Undercity",
	["Valiance Expedition"] = "Valiance Expedition",
	["Warsong Offensive"] = "Warsong Offensive",
	["Warsong Outriders"] = "Warsong Outriders",
	["Wildhammer Clan"] = "Wildhammer Clan",
	["Winterfin Retreat"] = "Winterfin Retreat",
	["Wintersaber Trainers"] = "Wintersaber Trainers",
	["Zandalar Tribe"] = "Zandalar Tribe",
}


if GAME_LOCALE == "enUS" then
	lib:SetCurrentTranslations(true)
elseif GAME_LOCALE == "deDE" then
	lib:SetCurrentTranslations {
	-- Acquaintance = "",
	Alliance = "Allianz",
	["Alliance Vanguard"] = "Vorposten der Allianz",
	["Argent Crusade"] = "Argentumkreuzzug",
	["Argent Dawn"] = "Argentumdämmerung",
	["Ashtongue Deathsworn"] = "Die Todeshörigen",
	["Avengers of Hyjal"] = "Rächer des Hyjal",
	["Baradin's Wardens"] = "Wächter von Baradin",
	-- ["Best Friend"] = "",
	["Bilgewater Cartel"] = "Bilgewasserkartell",
	["Bloodsail Buccaneers"] = "Blutsegelbukaniere",
	["Booty Bay"] = "Beutebucht",
	["Brood of Nozdormu"] = "Brut Nozdormus",
	-- Buddy = "",
	["Cenarion Circle"] = "Zirkel des Cenarius",
	["Cenarion Expedition"] = "Expedition des Cenarius",
	-- ["Chee Chee"] = "",
	["Darkmoon Faire"] = "Dunkelmond-Jahrmarkt",
	["Darkspear Trolls"] = "Dunkelspeertrolle",
	Darnassus = "Darnassus",
	["Dragonmaw Clan"] = "Drachenmalklan",
	-- Ella = "",
	Everlook = "Ewige Warte",
	Exalted = "Ehrfürchtig",
	Exodar = "Die Exodar",
	["Explorers' League"] = "Forscherliga",
	-- ["Farmer Fung"] = "",
	-- ["Fish Fellreed"] = "",
	-- ["Forest Hozen"] = "",
	["Frenzyheart Tribe"] = "Stamm der Wildherzen",
	-- Friend = "",
	Friendly = "Freundlich",
	["Frostwolf Clan"] = "Frostwolfklan",
	Gadgetzan = "Gadgetzan",
	["Gelkis Clan Centaur"] = "Gelkisklan",
	Gilneas = "Gilneas",
	-- ["Gina Mudclaw"] = "",
	Gnomeregan = "Gnomeregan",
	["Gnomeregan Exiles"] = "Gnomeregangnome",
	-- ["Golden Lotus"] = "",
	-- ["Good Friend"] = "",
	["Guardians of Hyjal"] = "Wächter des Hyjal",
	Guild = "Gilde",
	-- ["Haohan Mudclaw"] = "",
	["Hellscream's Reach"] = "Höllschreis Hand",
	Honored = "Wohlwollend",
	["Honor Hold"] = "Ehrenfeste",
	Horde = "Horde",
	["Horde Expedition"] = "Expedition der Horde",
	-- ["Huojin Pandaren"] = "",
	["Hydraxian Waterlords"] = "Hydraxianer",
	Ironforge = "Eisenschmiede",
	-- ["Jogu the Drunk"] = "",
	["Keepers of Time"] = "Hüter der Zeit",
	["Kirin Tor"] = "Kirin Tor",
	["Knights of the Ebon Blade"] = "Ritter der Schwarzen Klinge",
	Kurenai = "Kurenai",
	["Lower City"] = "Unteres Viertel",
	["Magram Clan Centaur"] = "Magramklan",
	-- ["Nat Pagle"] = "",
	Netherwing = "Netherschwingen",
	Neutral = "Neutral",
	["Ogri'la"] = "Ogri'la",
	-- ["Old Hillpaw"] = "",
	-- ["Order of the Cloud Serpent"] = "",
	Orgrimmar = "Orgrimmar",
	-- ["Pearlfin Jinyu"] = "",
	Ramkahen = "Ramkahen",
	Ratchet = "Ratschet",
	Ravenholdt = "Rabenholdt",
	Revered = "Respektvoll",
	-- ["Shado-Pan"] = "",
	-- ["Shang Xi's Academy"] = "",
	["Sha'tari Skyguard"] = "Himmelswache der Sha'tari",
	["Shattered Sun Offensive"] = "Offensive der Zerschmetterten Sonne",
	["Shen'dralar"] = "Shen'dralar",
	-- Sho = "",
	["Silvermoon City"] = "Silbermond",
	["Silverwing Sentinels"] = "Silberschwingen",
	Sporeggar = "Sporeggar",
	["Stormpike Guard"] = "Sturmlanzengarde",
	Stormwind = "Sturmwind",
	-- Stranger = "",
	Syndicate = "Syndikat",
	["The Aldor"] = "Die Aldor",
	-- ["The Anglers"] = "",
	["The Ashen Verdict"] = "Das Äscherne Verdikt",
	-- ["The August Celestials"] = "",
	-- ["The Black Prince"] = "",
	-- ["The Brewmasters"] = "",
	["The Consortium"] = "Das Konsortium",
	["The Defilers"] = "Die Entweihten",
	["The Earthen Ring"] = "Der Irdene Ring",
	["The Frostborn"] = "Die Frosterben",
	["The Hand of Vengeance"] = "Die Hand der Rache",
	["The Kalu'ak"] = "Die Kalu'ak",
	-- ["The Klaxxi"] = "",
	["The League of Arathor"] = "Der Bund von Arathor",
	-- ["The Lorewalkers"] = "",
	["The Mag'har"] = "Die Mag'har",
	["The Oracles"] = "Die Orakel",
	Therazane = "Therazane",
	["The Scale of the Sands"] = "Die Wächter der Sande",
	["The Scryers"] = "Die Seher",
	["The Sha'tar"] = "Die Sha'tar",
	["The Silver Covenant"] = "Der Silberbund",
	["The Sons of Hodir"] = "Die Söhne Hodirs",
	["The Sunreavers"] = "Die Sonnenhäscher",
	["The Taunka"] = "Die Taunka",
	-- ["The Tillers"] = "",
	["The Violet Eye"] = "Das Violette Auge",
	["The Wyrmrest Accord"] = "Der Wyrmruhpakt",
	["Thorium Brotherhood"] = "Thoriumbruderschaft",
	Thrallmar = "Thrallmar",
	["Thunder Bluff"] = "Donnerfels",
	["Timbermaw Hold"] = "Holzschlundfeste",
	-- ["Tina Mudclaw"] = "",
	Tranquillien = "Tristessa",
	-- ["Tushui Pandaren"] = "",
	Undercity = "Unterstadt",
	["Valiance Expedition"] = "Expedition Valianz",
	["Warsong Offensive"] = "Kriegshymnenoffensive",
	["Warsong Outriders"] = "Vorhut des Kriegshymnenklan",
	["Wildhammer Clan"] = "Wildhammerklan",
	["Winterfin Retreat"] = "Zuflucht der Winterflossen",
	["Wintersaber Trainers"] = "Wintersäblerausbilder",
	["Zandalar Tribe"] = "Stamm der Zandalari",
}
elseif GAME_LOCALE == "frFR" then
	lib:SetCurrentTranslations {
	-- Acquaintance = "",
	Alliance = "Alliance",
	["Alliance Vanguard"] = "Avant-garde de l'Alliance",
	["Argent Crusade"] = "La Croisade d'argent",
	["Argent Dawn"] = "Aube d'argent",
	["Ashtongue Deathsworn"] = "Ligemort cendrelangue",
	["Avengers of Hyjal"] = "Vengeurs d’Hyjal",
	["Baradin's Wardens"] = "Gardiens de Baradin",
	-- ["Best Friend"] = "",
	["Bilgewater Cartel"] = "Cartel Baille-fonds",
	["Bloodsail Buccaneers"] = "La Voile sanglante",
	["Booty Bay"] = "Baie-du-Butin",
	["Brood of Nozdormu"] = "Progéniture de Nozdormu",
	-- Buddy = "",
	["Cenarion Circle"] = "Cercle cénarien",
	["Cenarion Expedition"] = "Expédition cénarienne",
	-- ["Chee Chee"] = "",
	["Darkmoon Faire"] = "Foire de Sombrelune",
	["Darkspear Trolls"] = "Trolls Sombrelance",
	Darnassus = "Darnassus",
	["Dragonmaw Clan"] = "Clan Gueule-de-dragon",
	-- Ella = "",
	Everlook = "Long-guet",
	Exalted = "Exalté",
	Exodar = "Exodar",
	["Explorers' League"] = "Ligue des explorateurs",
	-- ["Farmer Fung"] = "",
	-- ["Fish Fellreed"] = "",
	-- ["Forest Hozen"] = "",
	["Frenzyheart Tribe"] = "Tribu Frénécœur",
	-- Friend = "",
	Friendly = "Amical",
	["Frostwolf Clan"] = "Clan Loup-de-givre",
	Gadgetzan = "Gadgetzan",
	["Gelkis Clan Centaur"] = "Centaures (Gelkis)",
	Gilneas = "Gilnéas",
	-- ["Gina Mudclaw"] = "",
	Gnomeregan = "Gnomeregan",
	["Gnomeregan Exiles"] = "Exilés de Gnomeregan",
	-- ["Golden Lotus"] = "",
	-- ["Good Friend"] = "",
	["Guardians of Hyjal"] = "Gardiens d'Hyjal",
	Guild = "Guilde",
	-- ["Haohan Mudclaw"] = "",
	["Hellscream's Reach"] = "Poing de Hurlenfer",
	Honored = "Honoré",
	["Honor Hold"] = "Bastion de l'Honneur",
	Horde = "Horde",
	["Horde Expedition"] = "Expédition de la Horde",
	-- ["Huojin Pandaren"] = "",
	["Hydraxian Waterlords"] = "Les Hydraxiens",
	Ironforge = "Forgefer",
	-- ["Jogu the Drunk"] = "",
	["Keepers of Time"] = "Gardiens du Temps",
	["Kirin Tor"] = "Kirin Tor",
	["Knights of the Ebon Blade"] = "Chevaliers de la Lame d'ébène",
	Kurenai = "Kurenaï",
	["Lower City"] = "Ville basse",
	["Magram Clan Centaur"] = "Centaures (Magram)",
	-- ["Nat Pagle"] = "",
	Netherwing = "Aile-du-Néant",
	Neutral = "Neutre",
	["Ogri'la"] = "Ogri'la",
	-- ["Old Hillpaw"] = "",
	-- ["Order of the Cloud Serpent"] = "",
	Orgrimmar = "Orgrimmar",
	-- ["Pearlfin Jinyu"] = "",
	Ramkahen = "Ramkahen",
	Ratchet = "Cabestan",
	Ravenholdt = "Ravenholdt",
	Revered = "Révéré",
	-- ["Shado-Pan"] = "",
	-- ["Shang Xi's Academy"] = "",
	["Sha'tari Skyguard"] = "Garde-ciel sha'tari",
	["Shattered Sun Offensive"] = "Opération Soleil brisé",
	["Shen'dralar"] = "Shen'dralar",
	-- Sho = "",
	["Silvermoon City"] = "Lune-d'argent",
	["Silverwing Sentinels"] = "Sentinelles d'Aile-argent",
	Sporeggar = "Sporeggar",
	["Stormpike Guard"] = "Garde Foudrepique",
	Stormwind = "Hurlevent",
	-- Stranger = "",
	Syndicate = "Syndicat",
	["The Aldor"] = "L'Aldor",
	-- ["The Anglers"] = "",
	["The Ashen Verdict"] = "Le Verdict des cendres",
	-- ["The August Celestials"] = "",
	-- ["The Black Prince"] = "",
	-- ["The Brewmasters"] = "",
	["The Consortium"] = "Le Consortium",
	["The Defilers"] = "Les Profanateurs",
	["The Earthen Ring"] = "Le Cercle terrestre",
	["The Frostborn"] = "Les Givre-nés",
	["The Hand of Vengeance"] = "La Main de la vengeance",
	["The Kalu'ak"] = "Les Kalu'aks",
	-- ["The Klaxxi"] = "",
	["The League of Arathor"] = "La Ligue d'Arathor",
	-- ["The Lorewalkers"] = "",
	["The Mag'har"] = "Les Mag'har",
	["The Oracles"] = "Les Oracles",
	Therazane = "Therazane",
	["The Scale of the Sands"] = "La Balance des sables",
	["The Scryers"] = "Les Clairvoyants",
	["The Sha'tar"] = "Les Sha'tar",
	["The Silver Covenant"] = "Le Concordat argenté",
	["The Sons of Hodir"] = "Les Fils de Hodir",
	["The Sunreavers"] = "Les Saccage-soleil",
	["The Taunka"] = "Les Taunkas",
	-- ["The Tillers"] = "",
	["The Violet Eye"] = "L'Œil pourpre",
	["The Wyrmrest Accord"] = "L'Accord du Repos du ver",
	["Thorium Brotherhood"] = "Confrérie du thorium",
	Thrallmar = "Thrallmar",
	["Thunder Bluff"] = "Les Pitons du Tonnerre",
	["Timbermaw Hold"] = "Les Grumegueules",
	-- ["Tina Mudclaw"] = "",
	Tranquillien = "Tranquillien",
	-- ["Tushui Pandaren"] = "",
	Undercity = "Fossoyeuse",
	["Valiance Expedition"] = "Expédition de la Bravoure",
	["Warsong Offensive"] = "Offensive chanteguerre",
	["Warsong Outriders"] = "Voltigeurs Chanteguerre",
	["Wildhammer Clan"] = "Clan Marteau-hardi",
	["Winterfin Retreat"] = "Retraite des Ailerons-d'hiver",
	["Wintersaber Trainers"] = "Éleveurs de sabres-d'hiver",
	["Zandalar Tribe"] = "Tribu Zandalar",
}
elseif GAME_LOCALE == "koKR" then
	lib:SetCurrentTranslations {
	-- Acquaintance = "",
	Alliance = "얼라이언스",
	["Alliance Vanguard"] = "얼라이언스 선봉대",
	["Argent Crusade"] = "은빛십자군",
	["Argent Dawn"] = "은빛 여명회",
	["Ashtongue Deathsworn"] = "잿빛혓바닥 결사단",
	["Avengers of Hyjal"] = "하이잘의 복수자",
	["Baradin's Wardens"] = "바라딘 집행단",
	-- ["Best Friend"] = "",
	["Bilgewater Cartel"] = "빌지워터 무역회사",
	["Bloodsail Buccaneers"] = "붉은 해적단",
	["Booty Bay"] = "무법항",
	["Brood of Nozdormu"] = "노즈도르무 혈족",
	-- Buddy = "",
	["Cenarion Circle"] = "세나리온 의회",
	["Cenarion Expedition"] = "세나리온 원정대",
	-- ["Chee Chee"] = "",
	["Darkmoon Faire"] = "다크문 유랑단",
	["Darkspear Trolls"] = "검은창 트롤",
	Darnassus = "다르나서스",
	["Dragonmaw Clan"] = "용아귀 부족",
	-- Ella = "",
	Everlook = "눈망루 마을",
	Exalted = "확고한 동맹",
	Exodar = "엑소다르",
	["Explorers' League"] = "탐험가 연맹",
	-- ["Farmer Fung"] = "",
	-- ["Fish Fellreed"] = "",
	-- ["Forest Hozen"] = "",
	["Frenzyheart Tribe"] = "광란심장 일족",
	-- Friend = "",
	Friendly = "약간 우호적",
	["Frostwolf Clan"] = "서리늑대 부족",
	Gadgetzan = "가젯잔",
	["Gelkis Clan Centaur"] = "겔키스 부족 켄타로우스",
	Gilneas = "길니아스",
	-- ["Gina Mudclaw"] = "",
	Gnomeregan = "놈리건",
	["Gnomeregan Exiles"] = "놈리건",
	-- ["Golden Lotus"] = "",
	-- ["Good Friend"] = "",
	["Guardians of Hyjal"] = "하이잘의 수호자",
	Guild = "일반적으로 동업 조합", -- Needs review
	-- ["Haohan Mudclaw"] = "",
	["Hellscream's Reach"] = "헬스크림 세력단",
	Honored = "우호적",
	["Honor Hold"] = "명예의 요새",
	Horde = "호드",
	["Horde Expedition"] = "호드 원정대",
	-- ["Huojin Pandaren"] = "",
	["Hydraxian Waterlords"] = "히드락시안 물의 군주",
	Ironforge = "아이언포지",
	-- ["Jogu the Drunk"] = "",
	["Keepers of Time"] = "시간의 수호자",
	["Kirin Tor"] = "키린 토",
	["Knights of the Ebon Blade"] = "칠흑의 기사단",
	Kurenai = "쿠레나이",
	["Lower City"] = "고난의 거리",
	["Magram Clan Centaur"] = "마그람 부족 켄타로우스",
	-- ["Nat Pagle"] = "",
	Netherwing = "황천의 용군단",
	Neutral = "중립적",
	["Ogri'la"] = "오그릴라",
	-- ["Old Hillpaw"] = "",
	-- ["Order of the Cloud Serpent"] = "",
	Orgrimmar = "오그리마",
	-- ["Pearlfin Jinyu"] = "",
	Ramkahen = "람카헨",
	Ratchet = "톱니항",
	Ravenholdt = "라벤홀트",
	Revered = "매우 우호적",
	-- ["Shado-Pan"] = "",
	-- ["Shang Xi's Academy"] = "",
	["Sha'tari Skyguard"] = "샤타리 하늘경비대",
	["Shattered Sun Offensive"] = "무너진 태양 공격대",
	["Shen'dralar"] = "센드렐라",
	-- Sho = "",
	["Silvermoon City"] = "실버문",
	["Silverwing Sentinels"] = "은빛날개 파수대",
	Sporeggar = "스포어가르",
	["Stormpike Guard"] = "스톰파이크 경비대",
	Stormwind = "스톰윈드",
	-- Stranger = "",
	Syndicate = "비밀결사대",
	["The Aldor"] = "알도르 사제회",
	-- ["The Anglers"] = "",
	["The Ashen Verdict"] = "잿빛 선고단",
	-- ["The August Celestials"] = "",
	-- ["The Black Prince"] = "",
	-- ["The Brewmasters"] = "",
	["The Consortium"] = "무역연합",
	["The Defilers"] = "포세이큰 파멸단",
	["The Earthen Ring"] = "대지 고리회",
	["The Frostborn"] = "서릿결부족 드워프",
	["The Hand of Vengeance"] = "복수의 대리인",
	["The Kalu'ak"] = "칼루아크",
	-- ["The Klaxxi"] = "",
	["The League of Arathor"] = "아라소르 연맹",
	-- ["The Lorewalkers"] = "",
	["The Mag'har"] = "마그하르",
	["The Oracles"] = "점쟁이 조합",
	Therazane = "테라제인",
	["The Scale of the Sands"] = "시간의 중재자",
	["The Scryers"] = "점술가 길드",
	["The Sha'tar"] = "샤타르",
	["The Silver Covenant"] = "은빛 서약단",
	["The Sons of Hodir"] = "호디르의 후예",
	["The Sunreavers"] = "선리버",
	["The Taunka"] = "타운카",
	-- ["The Tillers"] = "",
	["The Violet Eye"] = "보랏빛 눈의 감시자",
	["The Wyrmrest Accord"] = "고룡쉼터 사원 용군단",
	["Thorium Brotherhood"] = "토륨 대장조합 ",
	Thrallmar = "스랄마",
	["Thunder Bluff"] = "썬더 블러프",
	["Timbermaw Hold"] = "나무구렁 요새",
	-- ["Tina Mudclaw"] = "",
	Tranquillien = "트랜퀼리엔",
	-- ["Tushui Pandaren"] = "",
	Undercity = "언더시티",
	["Valiance Expedition"] = "용맹의 원정대",
	["Warsong Offensive"] = "전쟁노래 공격대",
	["Warsong Outriders"] = "전쟁노래 정찰대",
	["Wildhammer Clan"] = "와일드해머 부족",
	["Winterfin Retreat"] = "겨울지느러미 은신처",
	["Wintersaber Trainers"] = "눈호랑이 조련사",
	["Zandalar Tribe"] = "잔달라 부족",
}
elseif GAME_LOCALE == "esES" then
	lib:SetCurrentTranslations {
	-- Acquaintance = "",
	Alliance = "Alianza",
	["Alliance Vanguard"] = "Vanguardia de la Alianza",
	["Argent Crusade"] = "Cruzada Argenta",
	["Argent Dawn"] = "El Alba Argenta",
	["Ashtongue Deathsworn"] = "Juramorte Lengua de ceniza",
	["Avengers of Hyjal"] = "Vengadores de Hyjal",
	["Baradin's Wardens"] = "Celadores de Baradin",
	-- ["Best Friend"] = "",
	["Bilgewater Cartel"] = "Cártel Pantoque",
	["Bloodsail Buccaneers"] = "Bucaneros Velasangre",
	["Booty Bay"] = "Bahía del Botín",
	["Brood of Nozdormu"] = "Linaje de Nozdormu",
	-- Buddy = "",
	["Cenarion Circle"] = "Círculo Cenarion",
	["Cenarion Expedition"] = "Expedición Cenarion",
	-- ["Chee Chee"] = "",
	["Darkmoon Faire"] = "Feria de la Luna Negra",
	["Darkspear Trolls"] = "Trols Lanza Negra",
	Darnassus = "Darnassus",
	["Dragonmaw Clan"] = "Clan Faucedraco",
	-- Ella = "",
	Everlook = "Vista Eterna",
	Exalted = "Exaltado",
	Exodar = "El Exodar",
	["Explorers' League"] = "Liga de Expedicionarios",
	-- ["Farmer Fung"] = "",
	-- ["Fish Fellreed"] = "",
	-- ["Forest Hozen"] = "",
	["Frenzyheart Tribe"] = "Tribu Corazón Frenético",
	-- Friend = "",
	Friendly = "Amistoso",
	["Frostwolf Clan"] = "Clan Lobo Gélido",
	Gadgetzan = "Gadgetzan",
	["Gelkis Clan Centaur"] = "Centauros del clan Gelkis",
	Gilneas = "Gilneas",
	-- ["Gina Mudclaw"] = "",
	Gnomeregan = "Gnomeran",
	["Gnomeregan Exiles"] = "Exiliados de Gnomeregan",
	-- ["Golden Lotus"] = "",
	-- ["Good Friend"] = "",
	["Guardians of Hyjal"] = "Guardianes de Hyjal",
	Guild = "Hermandad", -- Needs review
	-- ["Haohan Mudclaw"] = "",
	["Hellscream's Reach"] = "Mando Grito Infernal",
	Honored = "Honorable",
	["Honor Hold"] = "Bastión del Honor",
	Horde = "Horda",
	["Horde Expedition"] = "Expedición de la Horda",
	-- ["Huojin Pandaren"] = "",
	["Hydraxian Waterlords"] = "Srs. del Agua de Hydraxis",
	Ironforge = "Forjaz",
	-- ["Jogu the Drunk"] = "",
	["Keepers of Time"] = "Vigilantes del Tiempo",
	["Kirin Tor"] = "Kirin Tor",
	["Knights of the Ebon Blade"] = "Caballeros de la Espada de Ébano",
	Kurenai = "Kurenai",
	["Lower City"] = "Bajo Arrabal",
	["Magram Clan Centaur"] = "Centauros del clan Magram",
	-- ["Nat Pagle"] = "",
	Netherwing = "Ala Abisal",
	Neutral = "Neutral",
	["Ogri'la"] = "Ogri'la",
	-- ["Old Hillpaw"] = "",
	-- ["Order of the Cloud Serpent"] = "",
	Orgrimmar = "Orgrimmar",
	-- ["Pearlfin Jinyu"] = "",
	Ramkahen = "Ramkahen",
	Ratchet = "Trinquete",
	Ravenholdt = "Ravenholdt",
	Revered = "Reverenciado",
	-- ["Shado-Pan"] = "",
	-- ["Shang Xi's Academy"] = "",
	["Sha'tari Skyguard"] = "Guardia del cielo Sha'tari",
	["Shattered Sun Offensive"] = "Ofensiva Sol Devastado",
	["Shen'dralar"] = "Shen'dralar",
	-- Sho = "",
	["Silvermoon City"] = "Ciudad de Lunargenta",
	["Silverwing Sentinels"] = "Centinelas Ala de Plata",
	Sporeggar = "Esporaggar",
	["Stormpike Guard"] = "Guardia Pico Tormenta",
	Stormwind = "Ventormenta",
	-- Stranger = "",
	Syndicate = "La Hermandad",
	["The Aldor"] = "Los Aldor",
	-- ["The Anglers"] = "",
	["The Ashen Verdict"] = "El Veredicto Cinéreo",
	-- ["The August Celestials"] = "",
	-- ["The Black Prince"] = "",
	-- ["The Brewmasters"] = "",
	["The Consortium"] = "El Consorcio",
	["The Defilers"] = "Los Rapiñadores",
	["The Earthen Ring"] = "Anillo de la Tierra",
	["The Frostborn"] = "Los Natoescarcha",
	["The Hand of Vengeance"] = "La Mano de la Venganza",
	["The Kalu'ak"] = "Los Kalu'ak",
	-- ["The Klaxxi"] = "",
	["The League of Arathor"] = "Liga de Arathor",
	-- ["The Lorewalkers"] = "",
	["The Mag'har"] = "Los Mag'har",
	["The Oracles"] = "Los Oráculos",
	Therazane = "Therazane",
	["The Scale of the Sands"] = "La Escama de las Arenas",
	["The Scryers"] = "Los Arúspices",
	["The Sha'tar"] = "Los Sha'tar",
	["The Silver Covenant"] = "El Pacto de Plata",
	["The Sons of Hodir"] = "Los Hijos de Hodir",
	["The Sunreavers"] = "Los Atracasol",
	["The Taunka"] = "Los Taunka",
	-- ["The Tillers"] = "",
	["The Violet Eye"] = "El Ojo Violeta",
	["The Wyrmrest Accord"] = "El Acuerdo del Reposo del Dragón",
	["Thorium Brotherhood"] = "Hermandad del Torio",
	Thrallmar = "Thrallmar",
	["Thunder Bluff"] = "Cima del Trueno",
	["Timbermaw Hold"] = "Bastión Fauces de Madera",
	-- ["Tina Mudclaw"] = "",
	Tranquillien = "Tranquillien",
	-- ["Tushui Pandaren"] = "",
	Undercity = "Entrañas",
	["Valiance Expedition"] = "Expedición de Denuedo",
	["Warsong Offensive"] = "Ofensiva Grito de Guerra",
	["Warsong Outriders"] = "Escoltas Grito de Guerra",
	["Wildhammer Clan"] = "Clan Martillo Salvaje",
	["Winterfin Retreat"] = "Retiro Aleta Invernal",
	["Wintersaber Trainers"] = "Instructores de Sableinvernales",
	["Zandalar Tribe"] = "Tribu Zandalar",
}
elseif GAME_LOCALE == "esMX" then
	lib:SetCurrentTranslations {
	-- Acquaintance = "",
	Alliance = "Alianza",
	["Alliance Vanguard"] = "Vanguardia de la Alianza",
	["Argent Crusade"] = "Cruzada Argenta",
	["Argent Dawn"] = "El Alba Argenta",
	["Ashtongue Deathsworn"] = "Juramorte Lengua de ceniza",
	["Avengers of Hyjal"] = "Vengadores de Hyjal", -- Needs review
	["Baradin's Wardens"] = "Celadores de Baradin",
	-- ["Best Friend"] = "",
	["Bilgewater Cartel"] = "Cártel Pantoque",
	["Bloodsail Buccaneers"] = "Bucaneros Velasangre",
	["Booty Bay"] = "Bahía del Botín",
	["Brood of Nozdormu"] = "Linaje de Nozdormu",
	-- Buddy = "",
	["Cenarion Circle"] = "Círculo Cenarion",
	["Cenarion Expedition"] = "Expedición Cenarion",
	-- ["Chee Chee"] = "",
	["Darkmoon Faire"] = "Feria de la Luna Negra",
	["Darkspear Trolls"] = "Trols Lanza Negra",
	Darnassus = "Darnassus",
	["Dragonmaw Clan"] = "Clan Faucedraco",
	-- Ella = "",
	Everlook = "Vista Eterna",
	Exalted = "Exaltado",
	Exodar = "El Exodar",
	["Explorers' League"] = "Liga de Expedicionarios",
	-- ["Farmer Fung"] = "",
	-- ["Fish Fellreed"] = "",
	-- ["Forest Hozen"] = "",
	["Frenzyheart Tribe"] = "Tribu Corazón Frenético",
	-- Friend = "",
	Friendly = "Amistoso",
	["Frostwolf Clan"] = "Clan Lobo Gélido",
	Gadgetzan = "Gadgetzan",
	["Gelkis Clan Centaur"] = "Centauros del clan Gelkis",
	Gilneas = "Gilneas", -- Needs review
	-- ["Gina Mudclaw"] = "",
	Gnomeregan = "Gnomeregan", -- Needs review
	["Gnomeregan Exiles"] = "Exiliados de Gnomeregan",
	-- ["Golden Lotus"] = "",
	-- ["Good Friend"] = "",
	["Guardians of Hyjal"] = "Guardianes de Hyjal",
	-- Guild = "",
	-- ["Haohan Mudclaw"] = "",
	["Hellscream's Reach"] = "Mando Grito Infernal",
	Honored = "Honorable",
	["Honor Hold"] = "Bastión del Honor",
	Horde = "Horda",
	["Horde Expedition"] = "Expedición de la Horda",
	-- ["Huojin Pandaren"] = "",
	["Hydraxian Waterlords"] = "Srs. del Agua de Hydraxis",
	Ironforge = "Forjaz",
	-- ["Jogu the Drunk"] = "",
	["Keepers of Time"] = "Vigilantes del Tiempo",
	["Kirin Tor"] = "Kirin Tor",
	["Knights of the Ebon Blade"] = "Caballeros de la Espada de Ébano",
	Kurenai = "Kurenai",
	["Lower City"] = "Bajo Arrabal",
	["Magram Clan Centaur"] = "Centauros del clan Magram",
	-- ["Nat Pagle"] = "",
	Netherwing = "Ala Abisal",
	Neutral = "Neutral",
	["Ogri'la"] = "Ogri'la",
	-- ["Old Hillpaw"] = "",
	-- ["Order of the Cloud Serpent"] = "",
	Orgrimmar = "Orgrimmar",
	-- ["Pearlfin Jinyu"] = "",
	Ramkahen = "Ramkahen", -- Needs review
	Ratchet = "Trinquete",
	Ravenholdt = "Ravenholdt",
	Revered = "Reverenciado",
	-- ["Shado-Pan"] = "",
	-- ["Shang Xi's Academy"] = "",
	["Sha'tari Skyguard"] = "Guardia del cielo Sha'tari",
	["Shattered Sun Offensive"] = "Ofensiva Sol Devastado",
	["Shen'dralar"] = "Shen'dralar",
	-- Sho = "",
	["Silvermoon City"] = "Ciudad de Lunargenta",
	["Silverwing Sentinels"] = "Centinelas Ala de Plata",
	Sporeggar = "Esporaggar",
	["Stormpike Guard"] = "Guardia Pico Tormenta",
	Stormwind = "Ventormenta",
	-- Stranger = "",
	Syndicate = "La Hermandad",
	["The Aldor"] = "Los Aldor",
	-- ["The Anglers"] = "",
	["The Ashen Verdict"] = "El Veredicto Cinéreo",
	-- ["The August Celestials"] = "",
	-- ["The Black Prince"] = "",
	-- ["The Brewmasters"] = "",
	["The Consortium"] = "El Consorcio",
	["The Defilers"] = "Los Rapiñadores",
	["The Earthen Ring"] = "El Anillo de la Tierra",
	["The Frostborn"] = "Los Natoescarcha",
	["The Hand of Vengeance"] = "La Mano de la Venganza",
	["The Kalu'ak"] = "Los Kalu'ak",
	-- ["The Klaxxi"] = "",
	["The League of Arathor"] = "Liga de Arathor",
	-- ["The Lorewalkers"] = "",
	["The Mag'har"] = "Los Mag'har",
	["The Oracles"] = "Los Oráculos",
	Therazane = "Therazane", -- Needs review
	["The Scale of the Sands"] = "La Escama de las Arenas",
	["The Scryers"] = "Los Arúspices",
	["The Sha'tar"] = "Los Sha'tar",
	["The Silver Covenant"] = "El Pacto de Plata",
	["The Sons of Hodir"] = "Los Hijos de Hodir",
	["The Sunreavers"] = "Los Atracasol",
	["The Taunka"] = "Los taunka",
	-- ["The Tillers"] = "",
	["The Violet Eye"] = "El Ojo Violeta",
	["The Wyrmrest Accord"] = "El Acuerdo del Reposo del Dragón",
	["Thorium Brotherhood"] = "Hermandad del Torio",
	Thrallmar = "Thrallmar",
	["Thunder Bluff"] = "Cima del Trueno",
	["Timbermaw Hold"] = "Bastión Fauces de Madera",
	-- ["Tina Mudclaw"] = "",
	Tranquillien = "Tranquillien",
	-- ["Tushui Pandaren"] = "",
	Undercity = "Entrañas",
	["Valiance Expedition"] = "Expedición de Denuedo",
	["Warsong Offensive"] = "Ofensiva Grito de Guerra",
	["Warsong Outriders"] = "Escoltas Grito de Guerra",
	["Wildhammer Clan"] = "Clan Martillo Salvaje",
	["Winterfin Retreat"] = "Retiro Aleta Invernal",
	["Wintersaber Trainers"] = "Instructores de sableinvernales",
	["Zandalar Tribe"] = "Tribu Zandalar",
}
elseif GAME_LOCALE == "ptBR" then
	lib:SetCurrentTranslations {
	-- Acquaintance = "",
	Alliance = "Aliança",
	["Alliance Vanguard"] = "Vanguarda da Aliança",
	["Argent Crusade"] = "Cruzada Argêntea",
	["Argent Dawn"] = "Aurora Argêntea",
	["Ashtongue Deathsworn"] = "Devotos da Morte Grislíngua",
	["Avengers of Hyjal"] = "Vingadores de Hyjal",
	["Baradin's Wardens"] = "Protetores de Baradin",
	-- ["Best Friend"] = "",
	["Bilgewater Cartel"] = "Cartel Bondebico",
	["Bloodsail Buccaneers"] = "Bucaneiros da Vela Sangrenta",
	["Booty Bay"] = "Angra do Butim",
	["Brood of Nozdormu"] = "Prole de Nozdormu",
	-- Buddy = "",
	["Cenarion Circle"] = "Círculo Cenariano",
	["Cenarion Expedition"] = "Expedição Cenariana",
	-- ["Chee Chee"] = "",
	["Darkmoon Faire"] = "Feira de Negraluna",
	["Darkspear Trolls"] = "Trolls Lançanegra",
	Darnassus = "Darnassus",
	["Dragonmaw Clan"] = "Clã Presa do Dragão",
	-- Ella = "",
	Everlook = "Visteterna",
	Exalted = "Exaltado",
	Exodar = "Exodar",
	["Explorers' League"] = "Liga dos Exploradores",
	-- ["Farmer Fung"] = "",
	-- ["Fish Fellreed"] = "",
	-- ["Forest Hozen"] = "",
	["Frenzyheart Tribe"] = "Tribo Feralma",
	-- Friend = "",
	Friendly = "Respeitado",
	["Frostwolf Clan"] = "Clã Lobo do Gelo",
	Gadgetzan = "Geringontzan",
	["Gelkis Clan Centaur"] = "Clã dos Centauros Gelkis",
	Gilneas = "Guilnéas",
	-- ["Gina Mudclaw"] = "",
	Gnomeregan = "Gnomeregan",
	["Gnomeregan Exiles"] = "Gnomeregan",
	-- ["Golden Lotus"] = "",
	-- ["Good Friend"] = "",
	["Guardians of Hyjal"] = "Guardiões de Hyjal",
	Guild = "Guilda",
	-- ["Haohan Mudclaw"] = "",
	["Hellscream's Reach"] = "Confins do Grito Infernal",
	Honored = "Honrado",
	["Honor Hold"] = "Fortaleza da Honra",
	Horde = "Horda",
	["Horde Expedition"] = "Expedição da Horda",
	-- ["Huojin Pandaren"] = "",
	["Hydraxian Waterlords"] = "Senhores das Águas Hidraxianos",
	Ironforge = "Altaforja",
	-- ["Jogu the Drunk"] = "",
	["Keepers of Time"] = "Defensores do Tempo",
	["Kirin Tor"] = "Kirin Tor",
	["Knights of the Ebon Blade"] = "Cavaleiros da Lâmina de Ébano",
	Kurenai = "Kurenai",
	["Lower City"] = "Bairro Inferior",
	["Magram Clan Centaur"] = "Clã dos Centauros Magram",
	-- ["Nat Pagle"] = "",
	Netherwing = "Asa Etérea",
	Neutral = "Tolerado",
	["Ogri'la"] = "Ogri'la",
	-- ["Old Hillpaw"] = "",
	-- ["Order of the Cloud Serpent"] = "",
	Orgrimmar = "Orgrimmar",
	-- ["Pearlfin Jinyu"] = "",
	Ramkahen = "Ramkahen",
	Ratchet = "Vila Catraca",
	Ravenholdt = "Corvoforte",
	Revered = "Reverenciado",
	-- ["Shado-Pan"] = "",
	-- ["Shang Xi's Academy"] = "",
	["Sha'tari Skyguard"] = "Guarda Aérea de Sha'tari",
	["Shattered Sun Offensive"] = "Ofensiva Sol Partido",
	["Shen'dralar"] = "Shen'dralar",
	-- Sho = "",
	["Silvermoon City"] = "Luaprata",
	["Silverwing Sentinels"] = "Sentinelas da Asa de Prata",
	Sporeggar = "Sporeggar",
	["Stormpike Guard"] = "Guarda de Lançatroz",
	Stormwind = "Ventobravo",
	-- Stranger = "",
	Syndicate = "Camarilha",
	["The Aldor"] = "Os Aldor",
	-- ["The Anglers"] = "",
	["The Ashen Verdict"] = "Veredito Cinzento",
	-- ["The August Celestials"] = "",
	-- ["The Black Prince"] = "",
	-- ["The Brewmasters"] = "",
	["The Consortium"] = "O Consórcio",
	["The Defilers"] = "Os Profanadores",
	["The Earthen Ring"] = "Harmonia Telúrica",
	["The Frostborn"] = "Os Gelonatos",
	["The Hand of Vengeance"] = "A Mão da Vingança",
	["The Kalu'ak"] = "Os Kalu'ak",
	-- ["The Klaxxi"] = "",
	["The League of Arathor"] = "A Liga de Arathor",
	-- ["The Lorewalkers"] = "",
	["The Mag'har"] = "Os Mag'har",
	["The Oracles"] = "Os Oráculos",
	Therazane = "Therazane",
	["The Scale of the Sands"] = "A Escama das Areias",
	["The Scryers"] = "Os Áugures",
	["The Sha'tar"] = "Os Sha'tar",
	["The Silver Covenant"] = "O Pacto de Prata",
	["The Sons of Hodir"] = "Os Filhos de Hodir",
	["The Sunreavers"] = "Os Fendessol",
	["The Taunka"] = "Os Taunka",
	-- ["The Tillers"] = "",
	["The Violet Eye"] = "O Olho Violeta",
	["The Wyrmrest Accord"] = "A Aliança do Repouso das Serpes",
	["Thorium Brotherhood"] = "Irmandade do Tório",
	Thrallmar = "Thrallmar",
	["Thunder Bluff"] = "Penhasco do Trovão",
	["Timbermaw Hold"] = "Domínio dos Presamatos",
	-- ["Tina Mudclaw"] = "",
	Tranquillien = "Tranquillien",
	-- ["Tushui Pandaren"] = "",
	Undercity = "Cidade Baixa",
	["Valiance Expedition"] = "Expedição Valentia",
	["Warsong Offensive"] = "Ofensiva Brado Guerreiro",
	["Warsong Outriders"] = "Pioneiros do Brado Guerreiro",
	["Wildhammer Clan"] = "Clã Martelo Feroz",
	["Winterfin Retreat"] = "Retiro da Falésia Invernal",
	["Wintersaber Trainers"] = "Treinadores de Sabres-do-inverno",
	["Zandalar Tribe"] = "Tribo dos Zandalar",
}
elseif GAME_LOCALE == "itIT" then
	lib:SetCurrentTranslations {
	-- Acquaintance = "",
	Alliance = "Alleanza",
	["Alliance Vanguard"] = "Avanguardia Dell'Alleanza",
	["Argent Crusade"] = "Crociata d'Argento",
	["Argent Dawn"] = "Alba D'Argento",
	["Ashtongue Deathsworn"] = "Congiurati di Linguamorta",
	["Avengers of Hyjal"] = "Vendicatori di Hyjal",
	["Baradin's Wardens"] = "Custodi di Baradin",
	-- ["Best Friend"] = "",
	["Bilgewater Cartel"] = "Cartello degli Acqualorda",
	["Bloodsail Buccaneers"] = "Bucanieri Velerosse",
	["Booty Bay"] = "Baia del Bottino",
	["Brood of Nozdormu"] = "Stirpe di Nozdormu",
	-- Buddy = "",
	["Cenarion Circle"] = "Circolo Cenariano",
	["Cenarion Expedition"] = "Spedizione Cenariana",
	-- ["Chee Chee"] = "",
	["Darkmoon Faire"] = "Fiera di Lunacupa",
	["Darkspear Trolls"] = "Troll Lanciascura",
	Darnassus = "Darnassus",
	["Dragonmaw Clan"] = "Clan Fauci di Drago",
	-- Ella = "",
	Everlook = "Lungavista",
	Exalted = "Osannato",
	Exodar = "Exodar",
	["Explorers' League"] = "Lega degli Esploratori",
	-- ["Farmer Fung"] = "",
	-- ["Fish Fellreed"] = "",
	-- ["Forest Hozen"] = "",
	["Frenzyheart Tribe"] = "Tribù dei Cuorferoce",
	-- Friend = "",
	Friendly = "Amichevole",
	["Frostwolf Clan"] = "Clan Lupi Bianchi",
	Gadgetzan = "Meccania",
	["Gelkis Clan Centaur"] = "Centauri del Clan Gelkis",
	Gilneas = "Gilneas",
	-- ["Gina Mudclaw"] = "",
	Gnomeregan = "Gnomeregan",
	["Gnomeregan Exiles"] = "Esiliati di Gnomeregan",
	-- ["Golden Lotus"] = "",
	-- ["Good Friend"] = "",
	["Guardians of Hyjal"] = "Guardiani di Hyjal",
	Guild = "Gilda",
	-- ["Haohan Mudclaw"] = "",
	["Hellscream's Reach"] = "Avanguardia di Malogrido",
	Honored = "Onorato",
	["Honor Hold"] = "Rocca dell'Onore",
	Horde = "Orda",
	["Horde Expedition"] = "Spedizione dell'Orda",
	-- ["Huojin Pandaren"] = "",
	["Hydraxian Waterlords"] = "Seguaci di Hydraxian",
	Ironforge = "Foggiardente",
	-- ["Jogu the Drunk"] = "",
	["Keepers of Time"] = "Custodi del Tempo",
	["Kirin Tor"] = "Kirin Tor",
	["Knights of the Ebon Blade"] = "Cavalieri della Spada d'Ebano",
	Kurenai = "Kurenai",
	["Lower City"] = "Città Bassa",
	["Magram Clan Centaur"] = "Centauri del Clan Magram",
	-- ["Nat Pagle"] = "",
	Netherwing = "Alafatua",
	Neutral = "Neutrale",
	["Ogri'la"] = "Ogri'la",
	-- ["Old Hillpaw"] = "",
	-- ["Order of the Cloud Serpent"] = "",
	Orgrimmar = "Orgrimmar",
	-- ["Pearlfin Jinyu"] = "",
	Ramkahen = "Ramkahen",
	Ratchet = "Porto Paranco",
	Ravenholdt = "Corvolesto",
	Revered = "Riverito",
	-- ["Shado-Pan"] = "",
	-- ["Shang Xi's Academy"] = "",
	["Sha'tari Skyguard"] = "Guardiacieli Sha'tari",
	["Shattered Sun Offensive"] = "Offensiva del Sole Infranto",
	["Shen'dralar"] = "Shen'dralar",
	-- Sho = "",
	["Silvermoon City"] = "Lunargenta",
	["Silverwing Sentinels"] = "Sentinelle Alargentea",
	Sporeggar = "Sporeggar",
	["Stormpike Guard"] = "Guardia dei Piccatonante",
	Stormwind = "Roccavento",
	-- Stranger = "",
	Syndicate = "Lega dei Tagliagole",
	["The Aldor"] = "Veggenti",
	-- ["The Anglers"] = "",
	["The Ashen Verdict"] = "Verdetto Cinereo",
	-- ["The August Celestials"] = "",
	-- ["The Black Prince"] = "",
	-- ["The Brewmasters"] = "",
	["The Consortium"] = "Consorzio",
	["The Defilers"] = "Profanatori",
	["The Earthen Ring"] = "Circolo della Terra",
	["The Frostborn"] = "Figli del Gelo",
	["The Hand of Vengeance"] = "Mano della Vendetta",
	["The Kalu'ak"] = "Kalu'ak",
	-- ["The Klaxxi"] = "",
	["The League of Arathor"] = "Lega di Arathor",
	-- ["The Lorewalkers"] = "",
	["The Mag'har"] = "Mag'har",
	["The Oracles"] = "Tribù degli Oracoli",
	Therazane = "Therazane",
	["The Scale of the Sands"] = "Scale delle Sabbie",
	["The Scryers"] = "Veggenti",
	["The Sha'tar"] = "Sha'tar",
	["The Silver Covenant"] = "Patto d'Argento",
	["The Sons of Hodir"] = "Figli di Hodir",
	["The Sunreavers"] = "Predatori del Sole",
	["The Taunka"] = "Taunka",
	-- ["The Tillers"] = "",
	["The Violet Eye"] = "Occhio Violaceo",
	["The Wyrmrest Accord"] = "Lega dei Draghi",
	["Thorium Brotherhood"] = "Fratellanza del Torio",
	Thrallmar = "Thrallmar",
	["Thunder Bluff"] = "Picco del Tuono",
	["Timbermaw Hold"] = "Rifugio dei Mordilegno",
	-- ["Tina Mudclaw"] = "",
	Tranquillien = "Tranquillien",
	-- ["Tushui Pandaren"] = "",
	Undercity = "Sepulcra",
	["Valiance Expedition"] = "Spedizione degli Arditi",
	["Warsong Offensive"] = "Offensiva dei Cantaguerra",
	["Warsong Outriders"] = "Predoni Cantaguerra",
	["Wildhammer Clan"] = "Clan Granmartello",
	["Winterfin Retreat"] = "Rifugio dei Pinnafredda",
	["Wintersaber Trainers"] = "Addestratori delle Fiere Glaciali",
	["Zandalar Tribe"] = "Tribù Zandalari",
}
elseif GAME_LOCALE == "ruRU" then
	lib:SetCurrentTranslations {
	-- Acquaintance = "",
	Alliance = "Альянс",
	["Alliance Vanguard"] = "Авангард Альянса",
	["Argent Crusade"] = "Серебряный Авангард",
	["Argent Dawn"] = "Серебряный Рассвет",
	["Ashtongue Deathsworn"] = "Пеплоусты-служители",
	["Avengers of Hyjal"] = "Хиджальские мстители",
	["Baradin's Wardens"] = "Защитники Тол Барада",
	-- ["Best Friend"] = "",
	["Bilgewater Cartel"] = "Картель Трюмных Вод",
	["Bloodsail Buccaneers"] = "Пираты Кровавого Паруса",
	["Booty Bay"] = "Пиратская Бухта", -- Needs review
	["Brood of Nozdormu"] = "Род Ноздорму",
	-- Buddy = "",
	["Cenarion Circle"] = "Круг Кенария",
	["Cenarion Expedition"] = "Кенарийская экспедиция", -- Needs review
	-- ["Chee Chee"] = "",
	["Darkmoon Faire"] = "Ярмарка Новолуния",
	["Darkspear Trolls"] = "Тролли Черного Копья",
	Darnassus = "Дарнас",
	["Dragonmaw Clan"] = "Клан Драконьей Пасти",
	-- Ella = "",
	Everlook = "Круговзор",
	Exalted = "Превознесение",
	Exodar = "Экзодар",
	["Explorers' League"] = "Лига исследователей",
	-- ["Farmer Fung"] = "",
	-- ["Fish Fellreed"] = "",
	-- ["Forest Hozen"] = "",
	["Frenzyheart Tribe"] = "Племя Бешеного Сердца", -- Needs review
	-- Friend = "",
	Friendly = "Дружелюбие",
	["Frostwolf Clan"] = "Клан Северного Волка",
	Gadgetzan = "Прибамбасск",
	["Gelkis Clan Centaur"] = "Кентавры из племени Гелкис",
	Gilneas = "Гилнеас",
	-- ["Gina Mudclaw"] = "",
	Gnomeregan = "Гномреган",
	["Gnomeregan Exiles"] = "Изгнанники Гномрегана",
	-- ["Golden Lotus"] = "",
	-- ["Good Friend"] = "",
	["Guardians of Hyjal"] = "Стражи Хиджала",
	Guild = "Гильдия", -- Needs review
	-- ["Haohan Mudclaw"] = "",
	["Hellscream's Reach"] = "Батальон Адского Крика",
	Honored = "Уважение",
	["Honor Hold"] = "Оплот Чести",
	Horde = "Орда",
	["Horde Expedition"] = "Экспедиция Орды",
	-- ["Huojin Pandaren"] = "",
	["Hydraxian Waterlords"] = "Гидраксианские Повелители Вод",
	Ironforge = "Стальгорн",
	-- ["Jogu the Drunk"] = "",
	["Keepers of Time"] = "Хранители Времени",
	["Kirin Tor"] = "Кирин-Тор",
	["Knights of the Ebon Blade"] = "Рыцари Черного Клинка",
	Kurenai = "Куренай",
	["Lower City"] = "Нижний Город",
	["Magram Clan Centaur"] = "Кентавры из племени Маграм",
	-- ["Nat Pagle"] = "",
	Netherwing = "Крылья Пустоты",
	Neutral = "Равнодушие",
	["Ogri'la"] = "Огри'ла",
	-- ["Old Hillpaw"] = "",
	-- ["Order of the Cloud Serpent"] = "",
	Orgrimmar = "Оргриммар",
	-- ["Pearlfin Jinyu"] = "",
	Ramkahen = "Рамкахены",
	Ratchet = "Кабестан",
	Ravenholdt = "Черный Ворон",
	Revered = "Почтение",
	-- ["Shado-Pan"] = "",
	-- ["Shang Xi's Academy"] = "",
	["Sha'tari Skyguard"] = "Стражи Небес Ша'тар",
	["Shattered Sun Offensive"] = "Армия Расколотого Солнца",
	["Shen'dralar"] = "Шен'дралар",
	-- Sho = "",
	["Silvermoon City"] = "Луносвет",
	["Silverwing Sentinels"] = "Среброкрылые Часовые",
	Sporeggar = "Спореггар",
	["Stormpike Guard"] = "Стража Грозовой Вершины",
	Stormwind = "Штормград",
	-- Stranger = "",
	Syndicate = "Синдикат",
	["The Aldor"] = "Алдоры",
	-- ["The Anglers"] = "",
	["The Ashen Verdict"] = "Пепельный союз",
	-- ["The August Celestials"] = "",
	-- ["The Black Prince"] = "",
	-- ["The Brewmasters"] = "",
	["The Consortium"] = "Консорциум",
	["The Defilers"] = "Осквернители",
	["The Earthen Ring"] = "Служители Земли",
	["The Frostborn"] = "Зиморожденные",
	["The Hand of Vengeance"] = "Карающая Длань", -- Needs review
	["The Kalu'ak"] = "Калу'ак",
	-- ["The Klaxxi"] = "",
	["The League of Arathor"] = "Лига Аратора",
	-- ["The Lorewalkers"] = "",
	["The Mag'har"] = "Маг'хары",
	["The Oracles"] = "Оракулы",
	Therazane = "Теразан",
	["The Scale of the Sands"] = "Песчаная Чешуя",
	["The Scryers"] = "Провидцы",
	["The Sha'tar"] = "Ша'тар",
	["The Silver Covenant"] = "Серебряный союз", -- Needs review
	["The Sons of Hodir"] = "Сыны Ходира", -- Needs review
	["The Sunreavers"] = "Похитители Солнца", -- Needs review
	["The Taunka"] = "Таунка",
	-- ["The Tillers"] = "",
	["The Violet Eye"] = "Аметистовое Око",
	["The Wyrmrest Accord"] = "Драконий союз",
	["Thorium Brotherhood"] = "Братство Тория",
	Thrallmar = "Траллмар",
	["Thunder Bluff"] = "Громовой Утес",
	["Timbermaw Hold"] = "Древобрюхи",
	-- ["Tina Mudclaw"] = "",
	Tranquillien = "Транквиллион",
	-- ["Tushui Pandaren"] = "",
	Undercity = "Подгород",
	["Valiance Expedition"] = "Экспедиция Отважных",
	["Warsong Offensive"] = "Армия Песни Войны",
	["Warsong Outriders"] = "Всадники Песни Войны",
	["Wildhammer Clan"] = "Клан Громового Молота", -- Needs review
	["Winterfin Retreat"] = "Холодный Плавник",
	["Wintersaber Trainers"] = "Укротители ледопардов",
	["Zandalar Tribe"] = "Племя Зандалар",
}
elseif GAME_LOCALE == "zhCN" then
	lib:SetCurrentTranslations {
	Acquaintance = "认识的人", -- Needs review
	Alliance = "联盟",
	["Alliance Vanguard"] = "联盟先遣军",
	["Argent Crusade"] = "银色北伐军",
	["Argent Dawn"] = "银色黎明",
	["Ashtongue Deathsworn"] = "灰舌死誓者",
	["Avengers of Hyjal"] = "海加尔复仇者",
	["Baradin's Wardens"] = "巴拉丁典狱官",
	["Best Friend"] = "好友", -- Needs review
	["Bilgewater Cartel"] = "锈水财阀",
	["Bloodsail Buccaneers"] = "血帆海盗",
	["Booty Bay"] = "藏宝海湾",
	["Brood of Nozdormu"] = "诺兹多姆的子嗣",
	Buddy = "好友", -- Needs review
	["Cenarion Circle"] = "塞纳里奥议会",
	["Cenarion Expedition"] = "塞纳里奥远征队",
	["Chee Chee"] = "吱吱",
	["Darkmoon Faire"] = "暗月马戏团",
	["Darkspear Trolls"] = "暗矛巨魔",
	Darnassus = "达纳苏斯",
	["Dragonmaw Clan"] = "龙喉氏族",
	Ella = "艾拉",
	Everlook = "永望镇",
	Exalted = "崇拜",
	Exodar = "埃索达",
	["Explorers' League"] = "探险者协会",
	["Farmer Fung"] = "农夫老方",
	["Fish Fellreed"] = "玉儿·采苇",
	["Forest Hozen"] = "森林猢狲",
	["Frenzyheart Tribe"] = "狂心氏族",
	Friend = "朋友", -- Needs review
	Friendly = "友善",
	["Frostwolf Clan"] = "霜狼氏族",
	Gadgetzan = "加基森",
	["Gelkis Clan Centaur"] = "吉尔吉斯半人马",
	Gilneas = "吉尔尼斯",
	["Gina Mudclaw"] = "吉娜·泥爪",
	Gnomeregan = "诺莫瑞根",
	["Gnomeregan Exiles"] = "诺莫瑞根流亡者",
	["Golden Lotus"] = "金莲教",
	["Good Friend"] = "好友", -- Needs review
	["Guardians of Hyjal"] = "海加尔守护者",
	Guild = "公会",
	["Haohan Mudclaw"] = "郝瀚·泥爪",
	["Hellscream's Reach"] = "地狱咆哮近卫军",
	Honored = "尊敬",
	["Honor Hold"] = "荣耀堡",
	Horde = "部落",
	["Horde Expedition"] = "部落先遣军",
	["Huojin Pandaren"] = "火金派熊猫人",
	["Hydraxian Waterlords"] = "海达希亚水元素",
	Ironforge = "铁炉堡",
	["Jogu the Drunk"] = "醉鬼贾古",
	["Keepers of Time"] = "时光守护者",
	["Kirin Tor"] = "肯瑞托",
	["Knights of the Ebon Blade"] = "黑锋骑士团",
	Kurenai = "库雷尼",
	["Lower City"] = "贫民窟",
	["Magram Clan Centaur"] = "玛格拉姆半人马",
	["Nat Pagle"] = "纳特·帕格",
	Netherwing = "灵翼之龙",
	Neutral = "中立",
	["Ogri'la"] = "奥格瑞拉",
	["Old Hillpaw"] = "老农山掌",
	["Order of the Cloud Serpent"] = "云端翔龙骑士团",
	Orgrimmar = "奥格瑞玛",
	["Pearlfin Jinyu"] = "珠鳍锦鱼人",
	Ramkahen = "拉穆卡恒",
	Ratchet = "棘齿城",
	Ravenholdt = "拉文霍德",
	Revered = "崇敬",
	["Shado-Pan"] = "影踪派",
	["Shang Xi's Academy"] = "尚喜武院",
	["Sha'tari Skyguard"] = "沙塔尔天空卫士",
	["Shattered Sun Offensive"] = "破碎残阳",
	["Shen'dralar"] = "辛德拉",
	Sho = "阿烁",
	["Silvermoon City"] = "银月城",
	["Silverwing Sentinels"] = "银翼哨兵",
	Sporeggar = "孢子村",
	["Stormpike Guard"] = "雷矛卫队",
	Stormwind = "暴风城",
	Stranger = "陌生人", -- Needs review
	Syndicate = "辛迪加",
	["The Aldor"] = "奥尔多",
	["The Anglers"] = "垂钓翁",
	["The Ashen Verdict"] = "灰烬审判军",
	["The August Celestials"] = "至尊天神",
	["The Black Prince"] = "黑王子",
	["The Brewmasters"] = "酒仙会",
	["The Consortium"] = "星界财团",
	["The Defilers"] = "污染者",
	["The Earthen Ring"] = "大地之环",
	["The Frostborn"] = "霜脉矮人",
	["The Hand of Vengeance"] = "复仇之手",
	["The Kalu'ak"] = "卡鲁亚克",
	["The Klaxxi"] = "卡拉克西",
	["The League of Arathor"] = "阿拉索联军",
	["The Lorewalkers"] = "游学者",
	["The Mag'har"] = "玛格汉",
	["The Oracles"] = "神谕者",
	Therazane = "塞拉赞恩",
	["The Scale of the Sands"] = "流沙之鳞",
	["The Scryers"] = "占星者",
	["The Sha'tar"] = "沙塔尔",
	["The Silver Covenant"] = "银色盟约",
	["The Sons of Hodir"] = "霍迪尔之子",
	["The Sunreavers"] = "夺日者",
	["The Taunka"] = "牦牛人",
	["The Tillers"] = "阡陌客",
	["The Violet Eye"] = "紫罗兰之眼",
	["The Wyrmrest Accord"] = "龙眠联军",
	["Thorium Brotherhood"] = "瑟银兄弟会",
	Thrallmar = "萨尔玛",
	["Thunder Bluff"] = "雷霆崖",
	["Timbermaw Hold"] = "木喉要塞",
	["Tina Mudclaw"] = "迪娜·泥爪",
	Tranquillien = "塔奎林",
	["Tushui Pandaren"] = "土水派熊猫人",
	Undercity = "幽暗城",
	["Valiance Expedition"] = "无畏远征军",
	["Warsong Offensive"] = "战歌远征军",
	["Warsong Outriders"] = "战歌侦察骑兵",
	["Wildhammer Clan"] = "蛮锤部族",
	["Winterfin Retreat"] = "冬鳞避难所",
	["Wintersaber Trainers"] = "冬刃豹训练师",
	["Zandalar Tribe"] = "赞达拉部族",
}
elseif GAME_LOCALE == "zhTW" then
	lib:SetCurrentTranslations {
	Acquaintance = "認識的人", -- Needs review
	Alliance = "聯盟",
	["Alliance Vanguard"] = "聯盟先鋒",
	["Argent Crusade"] = "銀白十字軍",
	["Argent Dawn"] = "銀色黎明",
	["Ashtongue Deathsworn"] = "灰舌死亡誓言者",
	["Avengers of Hyjal"] = "海加爾復仇者",
	["Baradin's Wardens"] = "巴拉丁鐵衛",
	["Best Friend"] = "好友", -- Needs review
	["Bilgewater Cartel"] = "污水企業聯合",
	["Bloodsail Buccaneers"] = "血帆海盜",
	["Booty Bay"] = "藏寶海灣",
	["Brood of Nozdormu"] = "諾茲多姆的子嗣",
	Buddy = "好友", -- Needs review
	["Cenarion Circle"] = "塞納里奧議會",
	["Cenarion Expedition"] = "塞納里奧遠征隊",
	["Chee Chee"] = "奇奇",
	["Darkmoon Faire"] = "暗月馬戲團",
	["Darkspear Trolls"] = "暗矛食人妖",
	Darnassus = "達納蘇斯",
	["Dragonmaw Clan"] = "龍喉氏族",
	Ella = "艾拉",
	Everlook = "永望鎮",
	Exalted = "崇拜",
	Exodar = "艾克索達",
	["Explorers' League"] = "探險者協會",
	["Farmer Fung"] = "農夫老豐",
	["Fish Fellreed"] = "小魚·跌蘆",
	["Forest Hozen"] = "森林猴人",
	["Frenzyheart Tribe"] = "狂心部族",
	Friend = "朋友", -- Needs review
	Friendly = "友好",
	["Frostwolf Clan"] = "霜狼氏族",
	Gadgetzan = "加基森",
	["Gelkis Clan Centaur"] = "吉爾吉斯半人馬",
	Gilneas = "吉爾尼斯",
	["Gina Mudclaw"] = "吉娜·泥爪",
	Gnomeregan = "諾姆瑞根",
	["Gnomeregan Exiles"] = "諾姆瑞根流亡者",
	["Golden Lotus"] = "金蓮會",
	["Good Friend"] = "好友", -- Needs review
	["Guardians of Hyjal"] = "海加爾守護者",
	Guild = "公會",
	["Haohan Mudclaw"] = "好漢·泥爪",
	["Hellscream's Reach"] = "地獄吼先鋒",
	Honored = "尊敬",
	["Honor Hold"] = "榮譽堡",
	Horde = "部落",
	["Horde Expedition"] = "部落遠征軍",
	["Huojin Pandaren"] = "火金熊貓人",
	["Hydraxian Waterlords"] = "海達希亞水元素",
	Ironforge = "鐵爐堡",
	["Jogu the Drunk"] = "『酒鬼』酒骨",
	["Keepers of Time"] = "時光守望者",
	["Kirin Tor"] = "祈倫托",
	["Knights of the Ebon Blade"] = "黯刃騎士團",
	Kurenai = "卡爾奈",
	["Lower City"] = "陰鬱城",
	["Magram Clan Centaur"] = "瑪格拉姆半人馬",
	["Nat Pagle"] = "納特·帕格",
	Netherwing = "虛空之翼",
	Neutral = "中立",
	["Ogri'la"] = "歐格利拉",
	["Old Hillpaw"] = "老丘爪",
	["Order of the Cloud Serpent"] = "雲蛟衛",
	Orgrimmar = "奧格瑪",
	["Pearlfin Jinyu"] = "珠鰭錦魚人",
	Ramkahen = "蘭姆卡韓",
	Ratchet = "棘齒城",
	Ravenholdt = "拉文霍德",
	Revered = "崇敬",
	["Shado-Pan"] = "影潘",
	["Shang Xi's Academy"] = "尚羲學院",
	["Sha'tari Skyguard"] = "薩塔禦天者",
	["Shattered Sun Offensive"] = "破碎之日進攻部隊",
	["Shen'dralar"] = "辛德拉",
	Sho = "阿秀",
	["Silvermoon City"] = "銀月城",
	["Silverwing Sentinels"] = "銀翼哨兵",
	Sporeggar = "斯博格爾",
	["Stormpike Guard"] = "雷矛衛隊",
	Stormwind = "暴風城",
	Stranger = "陌生人", -- Needs review
	Syndicate = "辛迪加",
	["The Aldor"] = "奧多爾",
	["The Anglers"] = "釣手",
	["The Ashen Verdict"] = "灰燼裁決軍",
	["The August Celestials"] = "聖獸天尊",
	["The Black Prince"] = "黑龍王子",
	["The Brewmasters"] = "釀酒大師",
	["The Consortium"] = "聯合團",
	["The Defilers"] = "污染者",
	["The Earthen Ring"] = "陶土議會",
	["The Frostborn"] = "霜誕矮人",
	["The Hand of Vengeance"] = "復仇之手",
	["The Kalu'ak"] = "卡魯耶克",
	["The Klaxxi"] = "卡拉西",
	["The League of Arathor"] = "阿拉索聯軍",
	["The Lorewalkers"] = "博學行者",
	["The Mag'har"] = "瑪格哈",
	["The Oracles"] = "神諭者",
	Therazane = "瑟拉贊恩",
	["The Scale of the Sands"] = "流沙之鱗",
	["The Scryers"] = "占卜者",
	["The Sha'tar"] = "薩塔",
	["The Silver Covenant"] = "白銀誓盟",
	["The Sons of Hodir"] = "霍迪爾之子",
	["The Sunreavers"] = "奪日者",
	["The Taunka"] = "坦卡族",
	["The Tillers"] = "耕者工會",
	["The Violet Eye"] = "紫羅蘭之眼",
	["The Wyrmrest Accord"] = "龍眠協調者",
	["Thorium Brotherhood"] = "瑟銀兄弟會",
	Thrallmar = "索爾瑪",
	["Thunder Bluff"] = "雷霆崖",
	["Timbermaw Hold"] = "木喉要塞",
	["Tina Mudclaw"] = "蒂娜·泥爪",
	Tranquillien = "安寧地",
	["Tushui Pandaren"] = "土水熊貓人",
	Undercity = "幽暗城",
	["Valiance Expedition"] = "驍勇遠征軍",
	["Warsong Offensive"] = "戰歌進攻部隊",
	["Warsong Outriders"] = "戰歌先遣騎",
	["Wildhammer Clan"] = "蠻錘氏族",
	["Winterfin Retreat"] = "冬鰭避居地",
	["Wintersaber Trainers"] = "冬刃豹訓練師",
	["Zandalar Tribe"] = "贊達拉部族",
}

else
	error(("%s: Locale %q not supported"):format(MAJOR_VERSION, GAME_LOCALE))
end
